#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Quelle für Grundgerüst:
# http://www.ibm.com/developerworks/linux/tutorials/l-pysocks/#N10518
#
import socket
import select
import random
import hashlib
import time
import datetime

password_ATmega="Passw0rd_M"  # Challenge kommt vom ATmega
password_Python="Passw0rd_P"  # Challenge kommt vom Python-Script

# Liefert Datum+Uhrzeit immer als Winter- bzw. Normalzeit.
def getNormTime():
  now=datetime.datetime.now()
  if time.localtime().tm_isdst==1:
    now=now+datetime.timedelta(hours=-1)
  return(now.strftime("%Y.%m.%d %H:%M:%S"))



class SocketServer:
  def __init__(self, port):
    self.port=port;
    self.srvsock=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    self.srvsock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    self.srvsock.bind(("", port))
    self.srvsock.listen(5)
    self.descriptors=[self.srvsock]
    print 'SocketServer started on port %s'%port
    self.state="WAIT"


  def run(self):
    while 1:
      (sread, swrite, sexc)=select.select(self.descriptors, [], [])
      for sock in sread:
        if sock==self.srvsock:
          self.accept_new_connection()
        else:
          strg=sock.recv(100)
          if strg=='':
            host, port=sock.getpeername()
            strg='Client left %s:%s'%(host, port)
            print strg
            sock.close()
            self.descriptors.remove(sock)
            self.state="WAIT"
          else:
            print "\nreceived:", strg
            host, port=sock.getpeername()
            if self.state=="WAIT" and strg=="AUTH_REQ":
              self.rand_number=str(random.randint(100000000, 999999999))
              print "\nsende challenge"
              self.send_string(self.rand_number)
              self.state="AUTH_REQ_CHALLENGE_SENT"
            elif self.state=="AUTH_REQ_CHALLENGE_SENT":
              self.md5hash=strg
              md5=hashlib.md5(self.rand_number+password_Python).hexdigest()
              print "my md5 = ", md5
              if md5==self.md5hash:
                self.state="AUTHORIZED_1"
                self.send_string("AUTHORIZED")
              else:
                self.state="WAIT"
                self.send_string("NOT AUTHORIZED")
            elif self.state=="AUTHORIZED_1":
              self.rand_number=strg
              md5=hashlib.md5(self.rand_number+password_ATmega).hexdigest()
              self.send_string(md5)
              self.state="AUTHORIZED_2"
            elif self.state=="AUTHORIZED_2":
              if strg=="AUTHORIZED":
                self.send_string("FINE")
                self.state="AUTHORIZED"
              else:
                self.send_string("BYE")
                sock.close()
                self.descriptors.remove(sock)
                self.state="WAIT"
            elif self.state=="AUTHORIZED" and strg=="TIME_INFO":
              self.state="TIME_INFO"
              self.send_string("OK")
            elif self.state=="TIME_INFO":
              print "Time-Info:", strg
              self.state="AUTHORIZED"
              self.send_string("OK")
            elif self.state=="AUTHORIZED" and strg=="GET_TIME":
              self.send_string(getNormTime())
            else:
              self.send_string("ECHO:"+strg)


  def send_string(self, strg):
    for sock in self.descriptors:
      if sock!=self.srvsock:
        sock.send(strg)
    print "sent:", strg


  def accept_new_connection(self):
    newsock, (remhost, remport)=self.srvsock.accept()
    self.descriptors.append(newsock)
    strg='Client joined %s:%s'%(remhost, remport)
    print strg,


if __name__=='__main__':
  myServer=SocketServer(2626)
  myServer.run()
